a// ACEdit.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "ACEdit.h"
#include  <io.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define _EDIT_ 1
#define _COMBOBOX_ 2


#ifndef _countof
#define _countof(array) (sizeof(array)/sizeof(array[0]))
#endif

//#define _AC_WANTTAB
/////////////////////////////////////////////////////////////////////////////
// CACEdit

#ifdef _AC_WANTTAB
extern UINT PLWM_EDIT_COMPLETE;
/*
	UINT PLWM_EDIT_COMPLETE = ::RegisterWindowMessage(PLWM_EDIT_COMPLETE_MSG);
*/
#endif

/**********************************************************************/

CACEdit::CACEdit()
{
	m_iMode = _MODE_STANDARD_;
	m_iType = -1;
	m_pEdit = NULL;
	m_bCursorMode = false;
	m_cPrefixChar = 0;
	dwDragAcceptFlags = 0;
}

/*********************************************************************/

CACEdit::~CACEdit()
{
	DestroyWindow();
}

/*********************************************************************/

BEGIN_MESSAGE_MAP(CACEdit, CWnd)
	//{{AFX_MSG_MAP(CACEdit)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillfocus)
	ON_WM_KEYDOWN()
	ON_CONTROL_REFLECT_EX(EN_CHANGE, OnChange)
	ON_CONTROL_REFLECT(CBN_DROPDOWN, OnCloseList)
	ON_CONTROL_REFLECT(CBN_KILLFOCUS, OnKillfocus)
	ON_CONTROL_REFLECT_EX(CBN_EDITCHANGE, OnChange)
	ON_WM_MOUSEWHEEL()
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
	ON_MESSAGE(ENAC_UPDATE, OnUpdateFromList)
END_MESSAGE_MAP()

/*********************************************************************/

void CACEdit::SetMode(int iMode)
{
	if(m_iType == -1)
		Init();

	m_iMode = iMode;

	/*
	** Vers. 1.1
	** NEW: _MODE_CURSOR_O_LIST_
	*/
	if(iMode == _MODE_CURSOR_O_LIST_)
		m_iMode |= _MODE_STANDARD_;

	if(iMode & _MODE_FILESYSTEM_ || iMode & _MODE_REGISTRY_) // 1.9
		m_SeparationStr = _T("\\");

	// Vers. 1.2
	if(iMode & _MODE_FIND_ALL_)
		{
		m_Liste.m_lMode |= _MODE_FIND_ALL_;
		}
}

/*********************************************************************/
#define CS_DROPSHADOW       0x00020000

int ACGetMiniWindowVers()
{
	OSVERSIONINFO osvi;
	osvi.dwOSVersionInfoSize = sizeof (osvi);
	::GetVersionEx (&osvi);
	if(osvi.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{
		if(osvi.dwMajorVersion > 6) // win8
			return 70;
		if(osvi.dwMajorVersion == 6 && osvi.dwMinorVersion >= 1) // win7 // 2008 rc
			return 61;
		if(osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0) // vista // 2008 rc1
			return 60;
		if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion >= 1) // xp  // 2003
			return 51;
		if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0) // 2000
			return 50;
		}
	return 40;
}

/**********************************************************************/

void CACEdit::Init()
{
	DWORD dwFlags = CS_DROPSHADOW;

	if(ACGetMiniWindowVers() < 51)
		dwFlags = 0;
	
	CString szClassName = AfxRegisterWndClass(CS_CLASSDC|CS_SAVEBITS|CS_HREDRAW|CS_VREDRAW|dwFlags,
		0,(HBRUSH) (COLOR_WINDOW), 0);
	CRect rcWnd,rcWnd1;
	GetWindowRect(rcWnd);
	
	VERIFY(m_Liste.CreateEx(WS_EX_TOOLWINDOW,
		szClassName,NULL,
		WS_THICKFRAME | WS_CHILD | WS_BORDER |
		WS_CLIPSIBLINGS | WS_OVERLAPPED,
		CRect(rcWnd.left, rcWnd.top +20, rcWnd.left+ 200, rcWnd.top+200),
		GetDesktopWindow(), 
		0x3E8, NULL));
	
	CString m_ClassName;
	::GetClassName(GetSafeHwnd(), m_ClassName.GetBuffer(32), 32);
	m_ClassName.ReleaseBuffer();
	
	if (m_ClassName.Compare(_T("Edit")) == 0)
		{
		m_iType = _EDIT_;
		}
	else
		{
		if (m_ClassName.Compare(_T("ComboBox")) == 0)
			{
			m_iType = _COMBOBOX_;
			
			m_pEdit = (CEdit*)GetWindow(GW_CHILD);
			CAC1ASSERT(m_pEdit); // CBS_DROPDOWNLIST?
			::GetClassName(m_pEdit->GetSafeHwnd(), m_ClassName.GetBuffer(32), 32);
			m_ClassName.ReleaseBuffer();
			VERIFY(m_ClassName.Compare(_T("Edit")) == 0);
			}
		}
	
	if(m_iType == -1)
		{
		ASSERT(0);
		return;
		}
	
	m_Liste.Init(this);
}

/*********************************************************************/

void CACEdit::AddSearchStrings(LPCTSTR Strings[])
{
	int i = 0;
	LPCTSTR str;
	if(m_iType == -1) {ASSERT(0); return;}

	m_Liste.RemoveAll();

	do
		{
		str = Strings[i];
		if(str)
			{
			m_Liste.AddSearchString(str);
			}

		i++;
		}
	while(str);

	m_Liste.SortSearchList();
}

/*********************************************************************/

void CACEdit::AddSearchStrings(CStringArray* m_StringArray, bool m_bRemoveAll)
{
	ASSERT(m_StringArray);
	if(m_StringArray)
		{
		int size =  (int) m_StringArray->GetSize();
		if(m_iType == -1) {ASSERT(0); return;}

		if(m_bRemoveAll)
			m_Liste.RemoveAll();

		for(int i = 0; i < size; i++)
			m_Liste.AddSearchString(m_StringArray->GetAt(i));

		m_Liste.SortSearchList();
		}
}

/*********************************************************************/

/*********************************************************************
**	Vers. 1.5
**********************************************************************/
void CACEdit::AddSearchString(LPCTSTR lpszString)
{
	if(m_iType == -1) {ASSERT(0); return;} 

	m_Liste.AddSearchString(lpszString);
}

/*********************************************************************/

void CACEdit::RemoveSearchAll()
{
	if(m_iType == -1) {ASSERT(0); return;}

	m_Liste.RemoveAll();	
}

/*********************************************************************/

void CACEdit::OnKillfocus() 
{
	if(m_Liste.GetSafeHwnd()) // fix Vers 1.1
		m_Liste.ShowWindow(FALSE);
}

/*********************************************************************/

void CACEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(HandleKey(nChar,false) == false)
		CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

/*********************************************************************
**	Vers. 1.4
**  CodeProject: "A small bug in Init"
**	Info:	armkbdotcom 
**********************************************************************/
CEdit *CACEdit::GetEditCtrl()
{
	CEdit *m_pEditCtrl;
	if(m_iType == _COMBOBOX_)
		{
		m_pEditCtrl = (CEdit*)GetWindow(GW_CHILD);
		ASSERT(m_pEditCtrl); // CBS_DROPDOWNLIST??
		if(m_pEditCtrl)
			return m_pEditCtrl;
		}
	return NULL;
}

/**********************************************************************/

bool CACEdit::HandleKey(WPARAM nChar, bool m_bFromChild)
{
	if (nChar == VK_ESCAPE ||nChar == VK_RETURN)
		{
		m_Liste.ShowWindow(FALSE);
		return true;
		}

	if (nChar == VK_DOWN || nChar == VK_UP 
		|| nChar == VK_PRIOR || nChar == VK_NEXT
		|| nChar == VK_HOME || nChar == VK_END) 
		{

		// Vers. 1.4
		if(m_iType == _COMBOBOX_)
			if((m_pEdit = GetEditCtrl()) == NULL)
				return false;
		/*
		** Vers. 1.1
		** NEW: _MODE_CURSOR_O_LIST_
		*/
		if(m_Liste.IsWindowVisible() == FALSE && (m_iMode & _MODE_CURSOR_O_LIST_))
			{
			GetWindowText(m_EditText);

			if(m_EditText.IsEmpty())
				{
				m_Liste.CopyList();
				return true;
				}

			if(m_iMode & _MODE_FILESYSTEM_)
				ACPathMakePretty(m_EditText);
			}

		if(m_Liste.IsWindowVisible())
			{
			int pos;

			if(m_iMode & _MODE_STANDARD_ 
				|| m_iMode & _MODE_FILESYSTEM_
				|| m_iMode & _MODE_REGISTRY_	//1.9
				|| m_iMode & _MODE_FS_START_DIR_)
				{
				m_bCursorMode = true;
				
				if(m_bFromChild == false)
					m_EditText = m_Liste.GetNextString((int)nChar);
				else
					m_EditText = m_Liste.GetString();

				if(m_iMode & _MODE_FILESYSTEM_ || m_iMode & _MODE_REGISTRY_) //1.9
					{
					if (m_EditText.Right(1) == _T('\\'))
						m_EditText = m_EditText.Mid(0,m_EditText.GetLength()-1);
					}

				m_Liste.SelectItem(-1);
				SetWindowText(m_EditText);
				pos = m_EditText.GetLength();
				
				if(m_iType == _COMBOBOX_)
					{
					m_pEdit->SetSel(pos,pos,true);
					m_pEdit->SetModify(true);
					}

				if(m_iType == _EDIT_)
					{
					((CEdit*)this)->SetSel(pos,pos,true);
					((CEdit*)this)->SetModify(true);
					}

				GetParent()->SendMessage(ENAC_UPDATE, WM_KEYDOWN, GetDlgCtrlID());
				m_bCursorMode = false;
				return true;
				}

			if(m_iMode & _MODE_SEPARATION_)
				{
				CString m_Text,m_Left,m_Right;
				int left,right,pos=0,len;

				m_bCursorMode = true;

				GetWindowText(m_EditText);

				if(m_iType == _EDIT_)
					pos = LOWORD(((CEdit*)this)->CharFromPos(GetCaretPos()));

				if(m_iType == _COMBOBOX_)
					pos = m_pEdit->CharFromPos(m_pEdit->GetCaretPos());
				
				left  = FindSepLeftPos(pos-1,true);
				right = FindSepRightPos(pos);

				m_Text = m_EditText.Left(left);

				if(m_bFromChild == false)
					m_Text += m_Liste.GetNextString((int)nChar);
				else
					m_Text += m_Liste.GetString();
				
				m_Liste.SelectItem(-1);
				m_Text += m_EditText.Mid(right);
				len = m_Liste.GetString().GetLength();

				SetWindowText(m_Text);
				GetParent()->SendMessage(ENAC_UPDATE, WM_KEYDOWN, GetDlgCtrlID());
				
				right = FindSepLeftPos2(pos-1);
				left -= right;
				len += right;

				if(m_iType == _EDIT_)
					{
					((CEdit*)this)->SetModify(true);
					((CEdit*)this)->SetSel(left,left+len,false);
					}

				if(m_iType == _COMBOBOX_)
					{
					m_pEdit->SetModify(true);
					m_pEdit->SetSel(left,left+len,true);
					}

				m_bCursorMode = false;
				return true;
				}
			}
		}
	return false;
}

/*********************************************************************/

bool CACEdit::ACPathMakePretty(CString& m_Path)
{
	bool m_bChanged = false;
	if(m_Path.GetLength() >= 3)
		{
		bool m_bLoop = true;
		TCHAR cFirst = m_Path.GetAt(0);
		m_Path.SetAt(0, _T('*'));

		while(m_bLoop)
			{
			if(m_Path.Replace(_T("\\\\"), _T("\\")))
				m_bChanged = true;
			else
				m_bLoop = false;
			}
			
		m_Path.SetAt(0, cFirst);
		}
	return m_bChanged;
}

/**********************************************************************/

BOOL CACEdit::OnChange() 
{
	CString m_Text;
	int pos=0,len;
	
	if(m_iType == -1) 
		{ASSERT(0); return TRUE;}
	
	if(IsWindowVisible() == FALSE)
		return TRUE;

	GetWindowText(m_EditText);
	len = m_EditText.GetLength();
//----------------------------------------------
	if(m_iMode & _MODE_FILESYSTEM_ || m_iMode & _MODE_FS_START_DIR_ || m_iMode & _MODE_REGISTRY_) //1.9
		{
		ACPathMakePretty(m_EditText);

		if(m_bCursorMode == false)
			{

			// Vers. 1.4
			if(m_iType == _COMBOBOX_)
				if((m_pEdit = GetEditCtrl()) == NULL)
					return TRUE;

			if(m_iType == _EDIT_)
				pos = LOWORD(((CEdit*)this)->CharFromPos(GetCaretPos()));
		
			if(m_iType == _COMBOBOX_)
				pos = m_pEdit->CharFromPos(m_pEdit->GetCaretPos());

			if(m_iMode & _MODE_FS_START_DIR_)
				{
				if(len)
					m_Liste.FindString(-1,m_EditText);
				else
					m_Liste.ShowWindow(FALSE);
				}
			else
				{
				if((len > 2 || m_iMode & _MODE_REGISTRY_) && pos == len)
					{	
					if(m_iMode & _MODE_FILESYSTEM_)
						{
						if(_taccess(m_EditText,0) == 0)
							{
							ReadDirectory(m_EditText);
							}
						}
					else if(m_iMode & _MODE_REGISTRY_) // 1.9
						{
						if(ReadRegistry(m_EditText, true))
							ReadRegistry(m_EditText, false);
						}

					m_Liste.FindString(-1,m_EditText);
					}
				else
					m_Liste.ShowWindow(FALSE);
				}
			} // m_CursorMode
		}

//----------------------------------------------	
	if(m_iMode & _MODE_SEPARATION_)
		{
		if(m_bCursorMode == false)
			{
			if(m_iType == _EDIT_)
				pos = LOWORD(((CEdit*)this)->CharFromPos(GetCaretPos()));
		

			if(m_iType == _COMBOBOX_)
				pos = m_pEdit->CharFromPos(m_pEdit->GetCaretPos());

			int left,right;
			left  = FindSepLeftPos(pos-1);
			right = FindSepRightPos(pos);
			m_Text = m_EditText.Mid(left,right-left);
			m_Liste.FindString(-1,m_Text);
			}
		}
//----------------------------------------------
	if(m_iMode & _MODE_STANDARD_)
		{
		if(m_bCursorMode == false)
			m_Liste.FindString(-1,m_EditText);
		}
//----------------------------------------------

	GetParent()->SendMessage(ENAC_UPDATE, EN_UPDATE, GetDlgCtrlID());

	//Fix 1.8 / OnChange
	return FALSE;
}

/*********************************************************************/

int CACEdit::FindSepLeftPos(int pos, bool m_bIncludePrefix)
{
	int len = m_EditText.GetLength(), i; 
	TCHAR ch;

	if(pos >= len && len != 1)
		pos =  len -1;

	// (i) 1.5 vc2005
	for(i = pos; i >= 0 ; i--)
		{
		ch = m_EditText.GetAt(i);
		if(m_cPrefixChar == ch)
			return i + (m_bIncludePrefix ? 1 : 0);
		if(m_SeparationStr.Find(ch) != -1)
			break;
		}

	return  i + 1;
}

/*********************************************************************/

int CACEdit::FindSepLeftPos2(int pos)
{
	int len = m_EditText.GetLength(); 
	TCHAR ch;

	if(pos >= len && len != 1)
		pos =  len -1;
	
	if(len == 1)
		return 0;

	for(int i = pos; i >= 0 ; i--)
		{
		ch = m_EditText.GetAt(i);
		if(m_cPrefixChar == ch)
			return 1;
		}

	return  0;
}

/*********************************************************************/

int CACEdit::FindSepRightPos(int pos)
{
	int i, len = m_EditText.GetLength(); 
	TCHAR ch;

	// (i) 1.5 vc2005
	for(i = pos; i < len ; i++)
		{
		ch = m_EditText.GetAt(i);
		if(m_SeparationStr.Find(ch) != -1)
			break;
		}

	return i;
}

/*********************************************************************/

LONG CACEdit::OnUpdateFromList(WPARAM wParam, LPARAM /*lParam*/)
{
	UpdateData(true);

	if(wParam == WM_KEYDOWN)
		{
		HandleKey(VK_DOWN,true);
		}
	return 0;
}

/*********************************************************************/

void CACEdit::OnCloseList()
{
	m_Liste.ShowWindow(FALSE);
}

/*********************************************************************/

BOOL CACEdit::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
		{
		if(m_Liste.GetSafeHwnd())  // Fix 1.3.1
			{

#ifdef _AC_WANTTAB
			if(pMsg->wParam == VK_TAB)
				{
				GetParent()->SendMessage(PLWM_EDIT_COMPLETE, 1, (LPARAM)this);
				return true;
				}
#endif


			/**********************************************************************/
			
			if(m_Liste.IsWindowVisible())
				{
				if(m_iType == _COMBOBOX_)
					{
					if(pMsg->wParam == VK_DOWN || pMsg->wParam == VK_UP)
						if(HandleKey(pMsg->wParam,false))
							return true;
					}

				if(pMsg->wParam == VK_ESCAPE || pMsg->wParam == VK_RETURN)
					{
					if(HandleKey(pMsg->wParam,false))
						{
#ifdef _AC_WANTTAB
						GetParent()->SendMessage(PLWM_EDIT_COMPLETE, 0, (LPARAM)this);
#endif
						return true;
						}
					}
				}
#ifdef _AC_WANTTAB
			else
				{
				if(pMsg->wParam == VK_RETURN)
					{
					GetParent()->SendMessage(PLWM_EDIT_COMPLETE, 0, (LPARAM)this);
					return true;
					}
				}
#endif
			}
		}
	return CWnd::PreTranslateMessage(pMsg);
}

/*********************************************************************/

bool CACEdit::AddSlash(CString& m_Directory)
{
	m_Directory.ReleaseBuffer();

	if(m_Directory.IsEmpty())
		return false;

	if(m_Directory.Right(1) != _T("\\"))
		{
		m_Directory += _T("\\");
		return true;
		}

	return false;
}

/**********************************************************************/

bool CACEdit::RemoveSlash(CString& m_Path)
{
	if(m_Path.Right(1) == _T("\\")) 
		{
		m_Path = m_Path.Left(m_Path.GetLength()-1);
		return true;
		}
	return false;
}

/**********************************************************************/

LPCTSTR szACEdit_RegistryKeys[] = 
{
	_T("HKEY_CLASSES_ROOT"),
	_T("HKEY_CURRENT_USER"),
	_T("HKEY_LOCAL_MACHINE"),
	_T("HKEY_USERS"),
	_T("HKEY_CURRENT_CONFIG")
};

long m_LongACEdit_RegistryKeys = _countof(szACEdit_RegistryKeys);

/**********************************************************************/

/************************************************************************
* New : Version 1.9
************************************************************************/
bool CACEdit::ReadRegistry(CString m_Registry, bool m_bTestOnly)
{
	CWaitCursor hg;
	DWORD rc = ERROR_SUCCESS;
	HKEY hKey, hRootKey = NULL;
	int index = 0;
	TCHAR szSubKey[ 1024  +1] = _T("\0");
	DWORD length = sizeof( szSubKey );
	CString m_Key, m_Path;


	if(m_Registry.Find( _T("\\")) >= 0)
		m_Key = m_Registry.Left(m_Registry.Find( _T("\\")));
	
	m_Path = m_Registry;

	if(m_Key.CompareNoCase( _T("HKEY_CLASSES_ROOT") ) == 0)
		hRootKey = HKEY_CLASSES_ROOT;
	if(m_Key.CompareNoCase( _T("HKEY_CURRENT_USER") ) == 0)
		hRootKey = HKEY_CURRENT_USER;
	if(m_Key.CompareNoCase( _T("HKEY_LOCAL_MACHINE") ) == 0)
		hRootKey = HKEY_LOCAL_MACHINE;
	if(m_Key.CompareNoCase( _T("HKEY_USERS") ) == 0)
		hRootKey = HKEY_USERS;
	if(m_Key.CompareNoCase( _T("HKEY_CURRENT_CONFIG") ) == 0)
		hRootKey = HKEY_CURRENT_CONFIG;


	/**********************************************************************/
	
	if(hRootKey == NULL)
		{
		RemoveSearchAll();
		for(int i = 0; i < m_LongACEdit_RegistryKeys ;i++)
			AddSearchString(szACEdit_RegistryKeys[i]);
		return true;
		}

	/**********************************************************************/
	
	m_Registry = m_Key;

	if(m_Path.Find( _T("\\")) >= 0)
		m_Key = m_Path.Mid(m_Path.Find( _T("\\"))+1);
	else
		m_Key.Empty();

	RemoveSlash(m_Key);
	
	bool m_bIsOK = true;

	if (RegOpenKeyEx(hRootKey, m_Key.GetBuffer(0), 	0, KEY_ENUMERATE_SUB_KEYS |KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS)
		{
		if(m_Key.Find(_T("\\")) != -1)
			m_Key = m_Key.Mid(0,m_Key.ReverseFind(_T('\\')));
		else
			m_Key.Empty();

		if (RegOpenKeyEx(hRootKey, m_Key.GetBuffer(0), 	0, KEY_ENUMERATE_SUB_KEYS |KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS)
			m_bIsOK = false;
		}


	if(m_bIsOK)	
		{

		AddSlash(m_Registry);
		m_Registry += m_Key;
		AddSlash(m_Registry);

		RemoveSearchAll();

		if(m_bTestOnly == false)
			{
			rc = RegEnumKeyEx(hKey, index, szSubKey, &length, NULL, NULL, NULL, NULL);

			if(rc != ERROR_NO_MORE_ITEMS)
				{
				AddSearchString(m_Registry+szSubKey);
				
				while(rc == ERROR_SUCCESS) 
					{
					length = sizeof( szSubKey );
					index++;
					rc = RegEnumKeyEx(hKey, index, szSubKey, &length, NULL, NULL, NULL, NULL);
					if(rc != ERROR_NO_MORE_ITEMS)
						{
						AddSearchString(m_Registry+szSubKey);
						}
					}
				}
			}
		RegCloseKey(hKey);
		}
	else
		{
		RemoveSearchAll();
		return false;
		}
	return true;
}

/**********************************************************************/

void CACEdit::ReadDirectory(CString m_Dir)
{
	CFileFind FoundFiles;
	TCHAR ch;
	CWaitCursor hg;

	// Wenn mitten im Pfad,
	// vorheriges Verzeichnis einlesen.
	if (m_Dir.Right(1) != _T('\\'))
		{
		_tsplitpath(m_Dir, m_szDrive, m_szDir, m_szFname, m_szExt);
		m_Dir.Format(_T("%s%s"),m_szDrive, m_szDir);
		}
	
	//ist hbscher
	if(m_Dir.IsEmpty() == false)
		{
		ch = (TCHAR)towupper(m_Dir.GetAt(0));
		m_Dir.SetAt(0,ch);
		}

	CString m_Name,m_File,m_Dir1 = m_Dir;	
	if (m_Dir.Right(1) != _T('\\'))
		m_Dir += _T("\\");

	if(m_LastDirectory.CompareNoCase(m_Dir) == 0 && m_Liste.m_SearchList.GetSize())
		return;

	m_LastDirectory = m_Dir;
	m_Dir += _T("*.*");

	BOOL bContinue = FoundFiles.FindFile(m_Dir);
	if(bContinue)
		RemoveSearchAll();

	while (bContinue == TRUE)
		{
		bContinue = FoundFiles.FindNextFile();
		m_File = FoundFiles.GetFileName();

		if(FoundFiles.IsHidden() || FoundFiles.IsSystem())
			continue;
		if(FoundFiles.IsDirectory())
			{
			if(m_iMode & _MODE_ONLY_FILES)
				continue;
			if(FoundFiles.IsDots())
				continue;

			if (m_File.Right(1) != _T('\\'))
				m_File += _T("\\");
			}

		if(FoundFiles.IsDirectory() == FALSE)
			if(m_iMode & _MODE_ONLY_DIRS)
				continue;

		if(m_iMode & _MODE_FS_START_DIR_)
			{
			m_Name = m_File;
			}
		else
			{
			m_Name = m_Dir1;
			if (m_Name.Right(1) != _T('\\'))
				m_Name += _T("\\");
				
			m_Name += m_File;
			}

		AddSearchString(m_Name);
		}
	FoundFiles.Close();
	return;
}

/*********************************************************************/

void CACEdit::SetStartDirectory(CString m_Dir)
{
	if(m_iType == -1) {ASSERT(0); return;}

	if(m_iMode & _MODE_FS_START_DIR_)
		{
		AddSlash(m_Dir);
		ReadDirectory(m_Dir);
		}
}

/*********************************************************************
** CComboBox 
** NEW:V1.1
*********************************************************************/

int CACEdit::AddString( LPCTSTR lpszString )
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->AddString(lpszString);
		}
	return CB_ERR;
}

/*********************************************************************/

int CACEdit::SetDroppedWidth( UINT nWidth )
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->SetDroppedWidth(nWidth);
		}
	return CB_ERR;
}

/*********************************************************************/

int CACEdit::FindString( int nStartAfter, LPCTSTR lpszString )
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->FindString(nStartAfter,lpszString);
		}
	return CB_ERR;
}

/*********************************************************************/

int CACEdit::SelectString( int nStartAfter, LPCTSTR lpszString )
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->SelectString(nStartAfter,lpszString);
		}
	return CB_ERR;
}

/*********************************************************************/

void CACEdit::ShowDropDown(BOOL bShowIt)
{
	if(m_iType == _COMBOBOX_)
		{
		((CComboBox *)this)->ShowDropDown(bShowIt);
		}
}

/*********************************************************************/

void CACEdit::ResetContent()
{
	if(m_iType == _COMBOBOX_)
		{
		((CComboBox *)this)->ResetContent();
		}
}

/*********************************************************************/

// V1.5 / V.10(int)
int CACEdit::SetEditSel(int nStartChar, int nEndChar )
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->SetEditSel(nStartChar, nEndChar);
		}
	return CB_ERR;
}

/**********************************************************************/

/*********************************************************************
**	Vers. 1.5
**  CodeProject: "OnEnChangeEditXXX and Missing CEdit Methods"
**	Info:		intripoon  
**********************************************************************/
int CACEdit::SetSel(int nStartChar, int nEndChar, BOOL bNoScroll )
{
	if(m_iType == _EDIT_)
		{
		((CEdit *)this)->SetSel(nStartChar,nEndChar,bNoScroll);
		return CB_OKAY;
		}
	return CB_ERR;
}

/**********************************************************************/

int CACEdit::GetCurSel() const
{
	if(m_iType == _COMBOBOX_)
		{
		//Fix 1.7  codeproject:Graeme 
		CComboBox *pComboBox = ((CComboBox *)this);
		if(pComboBox)
			{
			int m_Pos = pComboBox->FindStringExact(-1, m_EditText);

			if(pComboBox->GetCurSel() != m_Pos && m_Pos != -1)
				{
				pComboBox->SetCurSel(m_Pos);
				}
			
			return pComboBox->GetCurSel();
			}
		}
	return CB_ERR;
}

/*********************************************************************/

int CACEdit::GetLBText( int nIndex, LPTSTR lpszText ) const
{
	if(m_iType == _COMBOBOX_)
		{
		return ((CComboBox *)this)->GetLBText(nIndex,lpszText);
		}
	return CB_ERR;
}

/*********************************************************************/

void CACEdit::GetLBText( int nIndex, CString& rString ) const
{
	if(m_iType == _COMBOBOX_)
		{
		((CComboBox *)this)->GetLBText(nIndex,rString);
		}
}

/*********************************************************************/

BOOL CACEdit::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	if(m_Liste.IsWindowVisible())
		return m_Liste.DoMouseWheel(nFlags, zDelta, pt);
	else
		return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

/**********************************************************************/

void CACEdit::DragAcceptFiles(BOOL bAccept, DWORD dwFlags)
{
	CWnd::DragAcceptFiles(bAccept);
	dwDragAcceptFlags |= dwFlags;
}

/**********************************************************************/
#if (_MSC_VER < 1400)
#define _tsplitpath_s(szPath, szDrive, iDrive, szDir, iDir, szFile, iFile, szExt, iExt) _tsplitpath(szPath, szDrive, szDir, szFile, szExt)
#endif

void CACEdit::OnDropFiles(HDROP hDropInfo) 
{
	if (this == GetCapture())
		ReleaseCapture();

	CString m_File = _T("");
	bool m_bOK = false;

	DragQueryFile(hDropInfo, 0, m_File.GetBuffer(_MAX_PATH), _MAX_PATH);
	m_File.ReleaseBuffer();
	DragFinish(hDropInfo);

	DWORD dwFileAttrib = GetFileAttributes(m_File);
	if(dwFileAttrib == 0xffffffff || dwDragAcceptFlags == 0)
		return;

	if(dwDragAcceptFlags & _ACCEPT_FOLDER_)
		{
		if ((dwFileAttrib & FILE_ATTRIBUTE_DIRECTORY) == 0)
			{
			TCHAR m_szDrive[_MAX_DRIVE] = {0}, m_szDir[_MAX_DIR] = {0};

#ifndef _CRT_SECURE_NO_DEPRECATE
			_tsplitpath_s(m_File, m_szDrive, _MAX_DRIVE, m_szDir, _MAX_DIR, NULL, 0, NULL, 0 );
#else
			_tsplitpath(m_File, m_szDrive, m_szDir, NULL, NULL);
#endif

			m_File.Format(_T("%s%s"), m_szDrive, m_szDir);
			AddSlash(m_File);
			DWORD dwFileAttrib = GetFileAttributes(m_File);
			if(dwFileAttrib & FILE_ATTRIBUTE_DIRECTORY)
				m_bOK = true;
			}
		else
			m_bOK = true;
		}

	if(dwDragAcceptFlags & _ACCEPT_FILE_ && !(dwFileAttrib & FILE_ATTRIBUTE_DIRECTORY))
		m_bOK = true;

	if(m_bOK == false)
		return;

	SetWindowText(m_File);
}

/**********************************************************************/
