#if !defined(AFX_ACEDIT_H__56D21C13_ECEA_41DF_AADF_55980E861AC2__INCLUDED_)
#define AFX_ACEDIT_H__56D21C13_ECEA_41DF_AADF_55980E861AC2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ACEdit.h : Header-Datei
//

/*********************************************************************
*
* CACEdit 1.10
* Copyright (c) 2003-11 by Andreas Kapust
* All rights reserved.
* info@applications
*
*********************************************************************/

#define CAC1ASSERT(x) ASSERT(x);if(x == NULL) return

#define _MODE_ONLY_FILES		(1L << 16)
#define _MODE_ONLY_DIRS			(1L << 17)

#define _MODE_STANDARD_			(1L << 0)
#define _MODE_SEPARATION_		(1L << 1)
#define _MODE_FILESYSTEM_		(1L << 2)
#define _MODE_FS_START_DIR_		(1L << 3)
#define _MODE_CURSOR_O_LIST_	(1L << 4)
#define _MODE_FIND_ALL_			(1L << 5)
#define _MODE_REGISTRY_			(1L << 6)

#define _MODE_FS_ONLY_FILE_	(_MODE_FILESYSTEM_|_MODE_ONLY_FILES)
#define _MODE_FS_ONLY_DIR_	(_MODE_FILESYSTEM_|_MODE_ONLY_DIRS)
#define _MODE_SD_ONLY_FILE_	(_MODE_FS_START_DIR_|_MODE_ONLY_FILES)
#define _MODE_SD_ONLY_DIR_	(_MODE_FS_START_DIR_|_MODE_ONLY_DIRS)  //Fix 1.2

#define _MODE_RG_ONLY_DIR_	(_MODE_REGISTRY_|_MODE_ONLY_DIRS)  // 1.9

#define _ACCEPT_FILE_		(1L << 0)
#define _ACCEPT_FOLDER_		(1L << 1)

/////////////////////////////////////////////////////////////////////////////
// Fenster CACEdit 
#include "ACListWnd.h"

class CACEdit : public CWnd //CEdit
{
// Konstruktion
public:
	CACEdit();


	void SetMode(int iMode=_MODE_STANDARD_);
	void SetSeparator(LPCTSTR lpszString,TCHAR lpszPrefixChar = 0)
		{
		m_SeparationStr = lpszString;
		m_Liste.m_cPrefixChar = m_cPrefixChar = lpszPrefixChar;
		SetMode(_MODE_SEPARATION_);
		}
	static bool AddSlash(CString& m_Directory);	// V1.9/V1.10
	static bool RemoveSlash(CString& m_Path);	// V1.9/V1.10


	// CComboBox
	int AddString(LPCTSTR lpszString);
	int GetLBText(int nIndex, LPTSTR lpszText ) const;
	int GetCurSel() const;

	int SetDroppedWidth(UINT nWidth);
	int FindString(int nStartAfter, LPCTSTR lpszString );
	int SelectString(int nStartAfter, LPCTSTR lpszString );
	int SetEditSel(int nStartChar, int nEndChar );

	void GetLBText(int nIndex, CString& rString ) const;
	void ShowDropDown(BOOL bShowIt = TRUE );
	void ResetContent();
	void CloseList(){OnCloseList();}
	void DisablePopup(bool m_Disable = true){m_Liste.DisabePopup(m_Disable);}
	void DragAcceptFiles(BOOL bAccept, DWORD dwFlags = _ACCEPT_FILE_);
	
	// CEdit 
	int SetSel(int nStartChar, int nEndChar, BOOL bNoScroll = FALSE);

	// Attribute
public:
	void Init();
	void AddSearchString(LPCTSTR lpszString);
	void AddSearchStrings(LPCTSTR Strings[]);
	void AddSearchStrings(CStringArray* m_StringArray, bool m_bRemoveAll = true); // 1.5 / 1.9
	void RemoveSearchAll();
	void SetStartDirectory(CString m_Dir);
	
	CEdit *GetEditCtrl();
// Operationen
public:

// berschreibungen
	// Vom Klassen-Assistenten generierte virtuelle Funktionsberschreibungen
	//{{AFX_VIRTUAL(CACEdit)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementierung
public:
	virtual ~CACEdit();
	CACListWnd m_Liste;
	// Generierte Nachrichtenzuordnungsfunktionen
protected:
	CString m_EditText, m_SeparationStr, m_LastDirectory;
	CEdit *m_pEdit;
	DWORD dwDragAcceptFlags;
	int m_iMode, m_iType;

	TCHAR m_cPrefixChar, m_szDrive[_MAX_DRIVE], m_szDir[_MAX_DIR],m_szFname[_MAX_FNAME], m_szExt[_MAX_EXT];
	bool m_bCursorMode;

	//{{AFX_MSG(CACEdit)
	afx_msg void OnKillfocus();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnChange(); 	// 1.8 afx_msg void OnChange();
	afx_msg void OnCloseList();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	//}}AFX_MSG
	afx_msg LONG OnUpdateFromList(WPARAM wParam, LPARAM	lParam);
	DECLARE_MESSAGE_MAP()
	

	/**********************************************************************/
		
	void ReadDirectory(CString m_Dir);

	bool ReadRegistry(CString m_Registry, bool m_bTestOnly);
	bool ACPathMakePretty(CString& m_Path);
	bool HandleKey(WPARAM nChar, bool m_bFromChild);
	
	int FindSepLeftPos(int pos, bool FindSepLeftPos = false);
	int FindSepLeftPos2(int pos);
	int FindSepRightPos(int pos);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // AFX_ACEDIT_H__56D21C13_ECEA_41DF_AADF_55980E861AC2__INCLUDED_
