// ACWnd.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "ACListWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static UINT auIDStatusBar[] = 
{ 
  ID_SEPARATOR
};

#define _MAX_ENTRYS_ 8
#define _MODE_FIND_ALL_			(1L << 5)

/////////////////////////////////////////////////////////////////////////////
// CACListWnd

// fix 1.6
CRect EXTERN_GetWorkArea(LPCRECT);

#ifdef  _DOPAINTMESSAGELOOP_
void DoPaintMessageLoop()
{
	MSG message1;
	while(::PeekMessage(&message1,NULL,WM_PAINT,WM_PAINT, PM_REMOVE))
		{
		::TranslateMessage(&message1);
		::DispatchMessage(&message1);
		}
}
#endif

/**********************************************************************/

CACListWnd::CACListWnd()
{
	m_lTopIndex = 0;
	m_lCount = 0;
	m_ItemHeight = 16;
	m_lSelItem = -1;
	m_VisibleItems = 0;
	m_pEditParent = NULL;
	m_LastSize.SetRectEmpty();
	m_cPrefixChar = 0;
	m_lMode = 0;
	m_bListIsDisabled = false;
	//Fix 1.7 Vista-Border
	m_SM_CXBORDER = 1;//GetSystemMetrics(SM_CXBORDER);
	m_SM_CYBORDER = 1; //GetSystemMetrics(SM_CYBORDER);
}

/**********************************************************************/

CACListWnd::~CACListWnd()
{
	m_SearchList.RemoveAll();
	m_DisplayList.RemoveAll();
	DestroyWindow();
}

/*********************************************************************/

void CACListWnd::OnActivateApp(BOOL bActive, DWORD dwThreadID) 
{
#if (_MSC_VER >= 1300)
	CWnd::OnActivateApp(bActive, dwThreadID);  //vc7    FIX 1.2
#else
	CWnd::OnActivateApp(bActive, (HTASK)dwThreadID); //vc6        FIX 1.2
#endif

	ShowWindow(FALSE);
}

/**********************************************************************/

BEGIN_MESSAGE_MAP(CACListWnd, CWnd)
	//{{AFX_MSG_MAP(CACListWnd)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_KEYDOWN()
	ON_WM_NCCALCSIZE()
	ON_WM_VSCROLL()
	ON_WM_ACTIVATEAPP()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_SETCURSOR()
	ON_WM_SHOWWINDOW()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_GETMINMAXINFO()
	ON_WM_NCHITTEST()
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CACListWnd 

// Fix: 1.7 (Vista-Border)
void CACListWnd::DrawItem(CDC* pDC,long m_lItem,long width)
{
	long y = (m_lItem - m_lTopIndex);
	CRect rcLabel(2+m_SM_CXBORDER,(y*m_ItemHeight)+m_SM_CYBORDER,
		width-m_SM_CXBORDER,((y+1)*m_ItemHeight)+m_SM_CYBORDER);

	pDC->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));

	if(m_lItem == m_lSelItem)
		{
		rcLabel.left = m_SM_CXBORDER;
		pDC->FillSolidRect(rcLabel,::GetSysColor(COLOR_HIGHLIGHT));
		pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		rcLabel.left = 2+m_SM_CXBORDER;
		}

	if(m_cPrefixChar)
		m_DisplayStr = m_cPrefixChar + m_DisplayList.GetAt(m_lItem);
	else
		m_DisplayStr = m_DisplayList.GetAt(m_lItem);

	//Fix: 1.10 CP: Yogurt
	UINT format = DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER | DT_END_ELLIPSIS;
	if ((::GetWindowLong (m_hWnd, GWL_EXSTYLE) & (WS_EX_RIGHT | WS_EX_RTLREADING)) != 0)
		format |= DT_RIGHT;
	else
		format |= DT_LEFT;
	pDC->DrawText(m_DisplayStr, -1, rcLabel, format);
}

/*********************************************************************/
// Fix: 1.7 (Vista-Border)
void CACListWnd::OnPaint() 
{
	CPaintDC dc(this);
	CRect rcWnd,m_rect, rc;
	CDC MemDC,*pDC=NULL;
	CBitmap  m_bitmap, *m_pOldBitmap;

	GetClientRect(rc);
	rcWnd = m_rect = rc;

	rc.left = rc.right-GetSystemMetrics(SM_CXHSCROLL);
	rc.top = rc.bottom-GetSystemMetrics(SM_CYVSCROLL);
	
	m_rect.right -= GetScrollBarWidth()-1;
	
	MemDC.CreateCompatibleDC(&dc);
	
	m_bitmap.CreateCompatibleBitmap(&dc, m_rect.Width(), m_rect.Height());
	m_pOldBitmap = MemDC.SelectObject(&m_bitmap);

	MemDC.SetWindowOrg(m_rect.left, m_rect.top);

	long width = rcWnd.Width() - GetScrollBarWidth();

	MemDC.FillSolidRect(rcWnd,::GetSysColor(COLOR_WINDOW));
	MemDC.SelectObject(GetStockObject(DEFAULT_GUI_FONT)); 
	MemDC.SetBkMode(TRANSPARENT);

	int i; // (i) 1.5 vc2005
	for(i = m_lTopIndex; i < m_lCount;i++)
		{
		DrawItem(&MemDC,i,width);
		}

	
	CPen m_Pen1(PS_SOLID, 1, ::GetSysColor(COLOR_WINDOW));
	CPen m_Pen2(PS_SOLID, 1, ::GetSysColor(COLOR_BTNFACE));
	CPen m_Pen3(PS_SOLID, 1, ::GetSysColor(COLOR_3DSHADOW));
	CPen m_Pen4(PS_SOLID, 1, ::GetSysColor(COLOR_WINDOWFRAME));


	pDC = &dc;

	if(m_VertBar.IsWindowVisible())
		dc.FillSolidRect(rc, ::GetSysColor(COLOR_BTNFACE) );
	else
		pDC = &MemDC;

	CPen *pOldPen = (CPen*)pDC->SelectObject(&m_Pen1);
	int a = 1,bottom;
	rc.OffsetRect(-1,1);

	width = GetSystemMetrics(SM_CXHSCROLL);
	bottom = (rcWnd.bottom-GetSystemMetrics(SM_CXHSCROLL))-1;

	//gripper
	// (i) 1.5 vc2005
	for(i = 0; i < 20 ;i++,a++)
		{
		if(a==1)
			pDC->SelectObject(&m_Pen1);
		if(a==2)
			pDC->SelectObject(&m_Pen2);
		if(a==3)
			pDC->SelectObject(&m_Pen3);
		if(a > 3)
			a = 0;
	
		pDC->MoveTo(rc.left + i - 1, rcWnd.bottom);
		pDC->LineTo(rc.left + i + width, bottom);
		}

	// Fix: 1.7 (Vista-Border)
	MemDC.SelectObject(&m_Pen4);
	MemDC.MoveTo(rcWnd.left, rcWnd.top);
	MemDC.LineTo(rcWnd.right-1, rcWnd.top);
	MemDC.LineTo(rcWnd.right-1, rcWnd.bottom-1);
	MemDC.LineTo(0, rcWnd.bottom-1);
	MemDC.LineTo(0, 0);

	if(m_VertBar.IsWindowVisible())
		{
		pDC->SelectObject(&m_Pen4);
		pDC->MoveTo(rcWnd.right-30, rcWnd.top);
		pDC->LineTo(rcWnd.right-1, rcWnd.top);
		pDC->LineTo(rcWnd.right-1, rcWnd.bottom-1);
		pDC->LineTo(rcWnd.right-30, rcWnd.bottom-1);
		}


	dc.BitBlt(m_rect.left, m_rect.top, m_rect.Width(), m_rect.Height(),
		&MemDC, m_rect.left, m_rect.top, SRCCOPY);

	pDC->SelectObject( pOldPen );
	MemDC.SelectObject(m_pOldBitmap);
}

/*********************************************************************/

void CACListWnd::Init(CWnd *pWnd)
{
	VERIFY(m_VertBar.Create(WS_VISIBLE|SBS_VERT|SBS_LEFTALIGN,
		CRect(0,0,GetSystemMetrics(SM_CYVSCROLL),100),this,0));
	
	SetScroller();
	m_pEditParent = (CEdit*)pWnd;

	m_lCount = (int)m_DisplayList.GetSize();
	m_VertBar.SetScrollPos(0,false);
	SetProp();

	CDC *m_pDC;
	m_pDC = GetDC();
	if(m_pDC)
		{
		m_pDC->SelectObject(GetStockObject(DEFAULT_GUI_FONT));
		//Fix: 1.10 CP: Yogurt
		CSize m_Size = m_pDC->GetOutputTextExtent(_T("ŊHg"));
		m_ItemHeight = m_Size.cy;
		ReleaseDC(m_pDC);
		}
}

/*********************************************************************/

void CACListWnd::SetScroller()
{
	CRect rcWnd,rcBar;
	GetClientRect(rcWnd);

	if(m_VertBar.GetSafeHwnd())
		{
		rcBar = rcWnd;
		rcBar.top = 1;
		rcBar.left = (rcWnd.Width()-GetSystemMetrics(SM_CYVSCROLL));
		rcBar.bottom-= GetSystemMetrics(SM_CYHSCROLL);
		rcBar.right = rcBar.left + GetSystemMetrics(SM_CYVSCROLL)-1;

		m_VertBar.MoveWindow(rcBar);
		rcBar.top = rcWnd.bottom-20;
		rcBar.bottom = rcWnd.bottom;
		m_VertBar.SetScrollPos(m_lTopIndex,true);	
		}	
}

/*********************************************************************/

void CACListWnd::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	SetScroller();
	SetProp();

	if(m_LastSize.IsRectEmpty() == FALSE)
		GetWindowRect(m_LastSize);
}

/*********************************************************************/

long CACListWnd::GetScrollBarWidth()
{
	if(m_VertBar.IsWindowVisible())
		return GetSystemMetrics(SM_CYVSCROLL);
	else
		return 0;
}

/*********************************************************************/

void CACListWnd::SetProp()
{
	CRect rcWnd,rcBar;

	if(m_lCount == 0)
		return;

	CWnd::GetWindowRect(rcWnd);
	ScreenToClient(rcWnd);

	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask =  SIF_PAGE|SIF_RANGE;
	si.nMin = 0;
	si.nMax =  m_lCount-1;
	
	// Fix: 1.8 /  -4 = top/bottom-border
	// ist hbscher ;-)
	m_VisibleItems = si.nPage = (rcWnd.Height()-4)/m_ItemHeight; 

	si.nTrackPos = 2;
	m_VertBar.SetScrollRange(0,m_lCount-1);
	m_VertBar.SetScrollInfo(&si);

	if(m_VisibleItems > m_lCount-1)
		m_VertBar.ShowWindow(FALSE);
	else if(m_bListIsDisabled == false)
		m_VertBar.ShowWindow(TRUE);

	if(m_lTopIndex+m_VisibleItems > m_lCount)
		{
		m_lTopIndex = m_lCount-m_VisibleItems;
		if(m_lTopIndex < 0)
			m_lTopIndex = 0;
		m_VertBar.SetScrollPos(m_lTopIndex,true);
		}
}

/*********************************************************************/

BOOL CACListWnd::OnEraseBkgnd(CDC* /*pDC*/) 
{
	return false;
}

/*********************************************************************/
// Fix: 1.7 (Vista-Border)
//void CACListWnd::OnNcPaint() 
//{
//	CWindowDC dc(this);
//	CRect rectClient, rectWindow,rcWnd;
//
//	GetClientRect(rectClient);
//	GetWindowRect(rectWindow);
//	ScreenToClient(rectWindow);
//	
//	rectClient.OffsetRect(-(rectWindow.left), -(rectWindow.top));
//	dc.ExcludeClipRect(rectClient);
//
//	rectWindow.OffsetRect(-rectWindow.left, -rectWindow.top);
//
//	dc.FillSolidRect(rectWindow,::GetSysColor(COLOR_WINDOWTEXT));
//}

/*********************************************************************/

void CACListWnd::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);

	if (nChar == VK_ESCAPE) 
		ShowWindow(FALSE);
}

/*********************************************************************/

// Fix: 1.7 (Vista-Border) / V.10
void CACListWnd::OnNcCalcSize(BOOL /*bCalcValidRects*/, NCCALCSIZE_PARAMS FAR* /*lpncsp*/) 
{
//	::InflateRect(lpncsp->rgrc, -0, -0);
}

/*********************************************************************/

int CACListWnd::HitTest(CPoint point)
{
	CRect rcItem;
	CRect rcWnd;

	GetClientRect(rcWnd);
	long width = rcWnd.Width() - GetScrollBarWidth();

	for(int i = m_lTopIndex; i < m_lCount; i++)
		{
		long y = i - m_lTopIndex;
		rcItem.SetRect(2,y*m_ItemHeight,width,(y+1)*m_ItemHeight);

		if(PtInRect(&rcItem, point))
			return (m_lSelItem = (y+m_lTopIndex));
		}

	return -1;
}

/*********************************************************************/
 
#if _MFC_VER < 0x0800  // Fix: 1.5
UINT CACListWnd::OnNcHitTest(CPoint point) 
#else
LRESULT CACListWnd::OnNcHitTest(CPoint point) 
#endif
{
	CRect rectClient;
	GetWindowRect(rectClient);

	rectClient.left = rectClient.right - GetSystemMetrics(SM_CYVSCROLL);
	rectClient.top = rectClient.bottom - GetSystemMetrics(SM_CXVSCROLL);

	if(rectClient.PtInRect(point))
		return HTBOTTOMRIGHT;
	else
		return HTCLIENT;
}

/*********************************************************************/

void CACListWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CWnd::OnLButtonDown(nFlags, point);
	int sel = HitTest(point);

	if(sel >= 0)
		{
		if(EnsureVisible(sel,true) == false)
			Invalidate();
		m_lSelItem = sel;
		m_pEditParent->SendMessage(ENAC_UPDATE, WM_KEYDOWN, GetDlgCtrlID());
		DoPaintMessageLoop();
		Sleep(500);
		ShowWindow(FALSE);
		}
	else
		{
		CRect rc;
		GetClientRect(rc);
		if(rc.PtInRect(point) == FALSE)
			ShowWindow(FALSE);
		}
}

/*********************************************************************/

void CACListWnd::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CWnd::OnRButtonDown(nFlags, point);
	ShowWindow(FALSE);
}

/*********************************************************************/

BOOL CACListWnd::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	CRect rectClient;
	CPoint ptCursor(GetMessagePos());
	ScreenToClient(&ptCursor);

	GetWindowRect(rectClient);
	ScreenToClient(&rectClient);

	rectClient.left = rectClient.right - GetSystemMetrics(SM_CYVSCROLL);
	rectClient.top = rectClient.bottom - GetSystemMetrics(SM_CXVSCROLL);


	if(rectClient.PtInRect(ptCursor)) // Resize-Cursor
		{
		return CWnd::OnSetCursor(pWnd, nHitTest, message);
		}
	
	::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	return TRUE;		
}

/*********************************************************************/

void CACListWnd::InvalidateAndScroll()
{
	m_VertBar.SetScrollPos(m_lTopIndex,true);
	Invalidate();
	DoPaintMessageLoop();
}

/*********************************************************************/

bool CACListWnd::EnsureVisible(int nItem, bool m_bWait)
{
	if(nItem > m_lTopIndex && nItem < m_lTopIndex + m_VisibleItems)
		return false; // is visible

	if(nItem > m_lTopIndex)	// scroll down
		{
		long m_len = nItem;
		for(int i = m_lTopIndex; i < m_len; i++)
			{
			if(i >= m_lCount-m_VisibleItems)
				break;
			if(i >= m_lCount-m_VisibleItems || i + m_VisibleItems > nItem)
				{
				break;
				}

			m_lTopIndex++;

			if(m_bWait)
				{
				InvalidateAndScroll();
				Sleep(10);
				DoPaintMessageLoop();
				}
			}
		InvalidateAndScroll();
		return true;
		}

	if(nItem < m_lTopIndex)	// scroll up
		{
		while(nItem < m_lTopIndex)
			{
			if(m_lTopIndex > 0)
				m_lTopIndex--;
			else
				{
				break;
				}

			if(m_bWait)
				{
				InvalidateAndScroll();
				Sleep(10);
				DoPaintMessageLoop();
				}
			}
		
		InvalidateAndScroll();
		return true;
		}

	return false;
}

/*********************************************************************/

bool CACListWnd::SelectItem(int nItem)
{
	if(nItem > m_lCount)
		return false;
	
	if(nItem == -1)
		{
		EnsureVisible(m_lSelItem,false);
		Invalidate();
		return false;
		}

	m_lSelItem = nItem;

	if(EnsureVisible(nItem,true) == false)
		Invalidate();

	return true;
}

/*********************************************************************/

int CACListWnd::FindStringExact( int nStartAfter, LPCTSTR lpszString )
{
	if(nStartAfter > m_SearchList.GetSize())
		return -1;

	for(int i = nStartAfter+1; i < m_SearchList.GetSize(); i++)
		if(m_SearchList.GetAt(i).Compare(lpszString) == 0)
			return i;
		return -1;
}

/*********************************************************************/

void CACListWnd::AdjustListPosition(CRect& rcWnd)
{
	CRect rectScreen, rcWnd2;
	::GetWindowRect(::GetDesktopWindow(), &rectScreen);

	rectScreen = EXTERN_GetWorkArea(rcWnd); // fix 1.6

	if(rcWnd.right > rectScreen.right)
		rcWnd.OffsetRect(-(rcWnd.right-rectScreen.right),0);
	if(rcWnd.bottom > rectScreen.bottom)
		rcWnd.OffsetRect(0,-(rcWnd.bottom-rectScreen.bottom));
}

/**********************************************************************/
/*
** Vers. 1.1
* NEW: m_bDisplayOnly
*/
int CACListWnd::FindString(int nStartAfter, LPCTSTR lpszString, bool m_bDisplayOnly)
{
	long m_AktCount = (int)m_DisplayList.GetSize();

	if(m_bDisplayOnly == false)
		{
		CString m_Str1,m_Str2 = lpszString;
		if(m_pEditParent == NULL)
			{
			ShowWindow(FALSE);
			return -1;
			}

		if(nStartAfter > m_SearchList.GetSize())
			{
			ShowWindow(FALSE);
			return -1;
			}

		if(m_Str2.IsEmpty())
			{
			ShowWindow(FALSE);
			return -1;
			}

		m_DisplayList.RemoveAll();

		//Fix: 1.10 CP: Yogurt
		//m_Str2.MakeUpper();

		for(int i = nStartAfter+1; i < m_SearchList.GetSize(); i++)
			{
			if(m_cPrefixChar)
				m_Str1 = m_cPrefixChar;
			else
				m_Str1.Empty();

			m_Str1 += m_SearchList.GetAt(i);

			//Fix: 1.10 CP: Yogurt
			//m_Str1.MakeUpper();

			if(m_lMode & _MODE_FIND_ALL_)
				{
				//Fix: 1.10 CP: Yogurt
				if(_tcsncicmp(m_Str1, m_Str2, m_Str2.GetLength()) == 0)
				//if(m_Str1.Find(m_Str2) >= 0)
					{
					m_DisplayList.Add(m_SearchList.GetAt(i));
					}
				}
			else  // _MODE_FIND_EXACT_
				{
				//Fix: 1.10 CP: Yogurt
				if(_tcsncicmp(m_Str1, m_Str2,m_Str2.GetLength()) == 0)
				//if(m_Str1.Find(m_Str2) == 0)
					{
					m_DisplayList.Add(m_SearchList.GetAt(i));
					}
				}
			}
		}

	m_lCount = (int)m_DisplayList.GetSize();

	if(m_lCount)
		{
		CRect rcWnd;
		int iHeight,iWidth;

		m_pEditParent->GetWindowRect(rcWnd);
		
		SetScroller();
		SetProp();
		
		if(m_bListIsDisabled == false)
			ShowWindow(TRUE);
		Invalidate();

		iHeight = m_lCount*m_ItemHeight+(m_SM_CYBORDER*2);
	
		if(m_lCount > _MAX_ENTRYS_)
			iHeight = _MAX_ENTRYS_*m_ItemHeight+(m_SM_CYBORDER*2);

	// V1.3
		if(m_LastSize.IsRectEmpty() == FALSE)
			{
			iWidth = m_LastSize.Width(); 
			iHeight = m_LastSize.Height(); 
			}
		else
			{
			iWidth = rcWnd.Width(); 
			}

		//Vista-fix
		//iWidth += m_SM_CXBORDER*2;

		rcWnd.top += rcWnd.Height();
		rcWnd.right = rcWnd.left+iWidth;
		rcWnd.bottom = rcWnd.top+iHeight;
		
		AdjustListPosition(rcWnd);

		SetWindowPos(&CWnd::wndTopMost, rcWnd.left,
			rcWnd.top,
			rcWnd.Width(), 
			rcWnd.Height(), 0);
	// V1.3

		if(m_AktCount != m_DisplayList.GetSize())
			m_lSelItem = -1;
		
		SortList(m_DisplayList);
		}
	else
		{
		ShowWindow(FALSE);
		}

	return 1;	
}

/*********************************************************************/

int CACListWnd::SelectString(LPCTSTR lpszString )
{
	int item = FindString(-1, lpszString);
	SelectItem(item);
	return item;
}

/*********************************************************************/

bool CACListWnd::GetText(int nItem, CString& m_Text)
{
	if(nItem < 0 || nItem > m_SearchList.GetSize())
		return false;
	m_Text = m_SearchList.GetAt(nItem);
	return true;
}

/*********************************************************************/

void CACListWnd::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	if(bShow)
		{
		m_nIDTimer =  (int)SetTimer( IDTimerInstall, 200, NULL);
		m_pEditParent->GetParent()->GetWindowRect(m_ParentRect);
		}
	else
		{
		if(m_nIDTimer)
			KillTimer(IDTimerInstall);
		m_nIDTimer = 0;
		m_lSelItem = -1;
		m_lTopIndex = 0;
		}

	CWnd::OnShowWindow(bShow, nStatus);
	::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
}

/*********************************************************************/

void CACListWnd::OnNcLButtonDown(UINT nHitTest, CPoint point) 
{
	if(OnNcHitTest(point) == HTBOTTOMRIGHT)
		GetWindowRect(m_LastSize);	
	CWnd::OnNcLButtonDown(nHitTest, point);
}

/*********************************************************************/

CString CACListWnd::GetString()
{
	int i = (int)m_DisplayList.GetSize();

	if(i == 0)
		return _T("");
	if(i <= m_lSelItem || m_lSelItem == -1)
		i = 0;
	else
		i = m_lSelItem;

	return m_DisplayList.GetAt(i);
}

/*********************************************************************/

void CACListWnd::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
	long m_oldlTopIndex = m_lTopIndex;

	switch(nSBCode)
		{
		case SB_ENDSCROLL:
			break;
		
		case SB_PAGEUP:
			m_lTopIndex -= m_VisibleItems;
			if(m_lTopIndex < 0)
				m_lTopIndex = 0;
			break;

		case SB_PAGEDOWN:
			m_lTopIndex += m_VisibleItems;
			if(m_lTopIndex >= m_lCount-m_VisibleItems)
				m_lTopIndex = m_lCount-m_VisibleItems;
			break;

		case SB_LINEUP:
			m_lTopIndex--;
			if(m_lTopIndex < 0)
				m_lTopIndex = 0;
			break;
		
		case SB_LINEDOWN:
			m_lTopIndex++;
			if(m_lTopIndex >= m_lCount-m_VisibleItems)
				m_lTopIndex = m_lCount-m_VisibleItems;
			break;
		
		case SB_THUMBTRACK:
			m_lTopIndex = nPos;
			break;
		}
	
	m_VertBar.SetScrollPos(m_lTopIndex,true);

	if(m_oldlTopIndex != m_lTopIndex)
		Invalidate();
}

/*********************************************************************/

CString CACListWnd::GetNextString(int nChar)
{
	switch(nChar)
		{
		case VK_DOWN:
			m_lSelItem++;
			break;
		
		case VK_UP:
			m_lSelItem--;
			break;
		
		case VK_PRIOR:
			m_lSelItem -= m_VisibleItems;
			if(m_lSelItem < 0)
				m_lSelItem = 0;
			break;
		
		case VK_NEXT:
			m_lSelItem += m_VisibleItems;
			if(m_lSelItem >= m_lCount-1)
				m_lSelItem = m_lCount-1;
			break;

		case VK_HOME:
			m_lSelItem = 0;
			break;
		
		case VK_END:
			m_lSelItem = m_lCount-1;
			break;
		}

	if(m_lSelItem < 0)
		m_lSelItem = m_lCount-1;
	
	if(m_lSelItem >= m_lCount)
		m_lSelItem = 0;

	if(EnsureVisible(m_lSelItem,(m_lCount > 50) ? false : true))
		InvalidateAndScroll();

	return GetString();
}

/*********************************************************************/
//V1.9
BOOL CACListWnd::DoMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	if (nFlags & (MK_SHIFT | MK_CONTROL))
		return FALSE;
	
	if(m_VertBar.IsWindowVisible() == FALSE)
		return FALSE;
	
	bool bResult = true;
	int nToScroll, nDisplacement, iCurFirstLine;

	
	iCurFirstLine = m_lTopIndex;
	nToScroll = ::MulDiv(-zDelta, 1, WHEEL_DELTA);

	if(nToScroll > 0)
		{
		nDisplacement = abs(nToScroll * (m_VisibleItems/4));
		m_lTopIndex += nDisplacement;
		m_lTopIndex = min(m_lTopIndex, m_lCount-m_VisibleItems);
		}
	else
		{
		nDisplacement = abs(nToScroll * (m_VisibleItems/4));
		m_lTopIndex -= nDisplacement;
		m_lTopIndex = max(0,m_lTopIndex);
		}
			
	if (iCurFirstLine != m_lTopIndex)
		{
		m_VertBar.SetScrollPos(m_lTopIndex, true );
		ScreenToClient(&pt);
		m_lSelItem = HitTest(pt);
		CWnd::Invalidate();
		}

	return bResult;
}

/**********************************************************************/

void CACListWnd::OnMouseMove(UINT nFlags, CPoint point) 
{
	CWnd::OnMouseMove(nFlags, point);
	int nSel = HitTest(point);
	if(nSel >= 0)
		{
		Invalidate();
		}
}

/*********************************************************************/

void CACListWnd::OnTimer(UINT nIDEvent) 
{
	CWnd::OnTimer(nIDEvent);

	CRect m_ParentRect1;
	m_pEditParent->GetParent()->GetWindowRect(m_ParentRect1);
	if(m_ParentRect1.EqualRect(m_ParentRect) == FALSE)
		ShowWindow(FALSE);
}

/*********************************************************************/

void CACListWnd::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if(GetSafeHwnd())
		{
		// Vers. 1.2 / fix 1.7 (vista border/m_SM_CYBORDER)
		long m_lMinY1 = GetSystemMetrics(SM_CYHSCROLL)*2 + GetSystemMetrics(SM_CYSIZEFRAME) + GetSystemMetrics(SM_CXHTHUMB),
			m_lMinY2 = m_lCount * m_ItemHeight + (m_SM_CYBORDER*2)+2;

		if(m_VisibleItems > m_lCount-1 &&  m_lMinY2 < m_lMinY1)
			lpMMI->ptMinTrackSize.y = m_lMinY2;
		else
			lpMMI->ptMinTrackSize.y = m_lMinY1;
		//---------

		lpMMI->ptMinTrackSize.x = GetSystemMetrics(SM_CXHSCROLL)*4;


		// Vers. 1.2
		if(m_pEditParent != NULL) 
			{
			RECT rc;
			m_pEditParent->GetWindowRect (&rc);
			lpMMI->ptMinTrackSize.x = rc.right - rc.left;
			}
		}
	else	
		CWnd::OnGetMinMaxInfo(lpMMI);
}

/*********************************************************************/

int __cdecl CACListWnd::SortListCompareString(const void* pStr1, const void* pStr2)
{
	return _tcsicmp( * ( TCHAR** ) pStr1, * ( TCHAR** ) pStr2 );
}

/*********************************************************************/

void CACListWnd::SortList(CStringArray& m_List)
{
	int i, m_nCount = (int)m_List.GetSize();
	
	if (m_nCount > 1)
		{
		CStringArray m_Liste1;
		m_Liste1.Copy(m_List);

		LPCTSTR* ppSortArray = new LPCTSTR[m_nCount+1];

		ASSERT(ppSortArray);
		if(ppSortArray == NULL)
			return;

		 // (i) 1.5 vc2005
		for(i = 0; i < m_nCount; i++)
			{
			ppSortArray[i] = (LPCTSTR)m_Liste1.GetAt(i);
			}

		m_List.RemoveAll();

		qsort(ppSortArray, m_nCount, sizeof(LPCTSTR), SortListCompareString);

		for(i = 0; i < m_nCount; i++)
			{
			m_List.Add((LPCTSTR) ppSortArray[i]);
			}
		m_Liste1.RemoveAll();
		delete [] ppSortArray;
		}
}

/*********************************************************************/
/*
** Vers. 1.1
** NEW: CopyList()
*/
void CACListWnd::CopyList()
{
	m_DisplayList.Copy(m_SearchList);
	m_lCount = (int)m_DisplayList.GetSize();
	if(m_lCount)
		FindString(0, _T(""),true);
}

/*********************************************************************/
